/*
  fstat.c

   This is for openVMS with EGCS 1.1 (based on GNU C 2.8)

   Copyright  by Klaus Kmpf (kkaempf@rmi.de) 1998

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that: (1) source code distributions
   retain the above copyright notice and this paragraph in its entirety, (2)
   distributions including binary code include the above copyright notice and
   this paragraph in its entirety in the documentation or other materials
   provided with the distribution, and (3) all advertising materials mentioning
   features or use of this software display the following acknowledgement:
   ``This product includes software developed by Klaus Kmpf, Nrnberg,
   Germany.''
   THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR IMPLIED
   WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
   MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.

 */

int
fstat (fd, buf)
     int fd;
     struct stat *buf;
{
  int status;
  int i;

  static struct FAB Fab;
  static struct NAM Nam;
  static struct fibdef Fib; /* short fib */
  static struct dsc$descriptor FibDesc =
    {sizeof(Fib), DSC$K_DTYPE_Z, DSC$K_CLASS_S, (char *)&Fib};
  static struct dsc$descriptor_s DevDesc =
    {0, DSC$K_DTYPE_T, DSC$K_CLASS_S, &Nam.nam$t_dvi[1]};
  static char EName[NAM$C_MAXRSS];
  static char RName[NAM$C_MAXRSS];
  static struct dsc$descriptor_s FileName =
    {0, DSC$K_DTYPE_T, DSC$K_CLASS_S, 0};
  static struct dsc$descriptor_s string =
    {0, DSC$K_DTYPE_T, DSC$K_CLASS_S, 0};  
  static unsigned long Rdate[2];
  static unsigned long Cdate[2];
  static struct atrdef Atr[] = {  
    {sizeof(Rdate),ATR$C_REVDATE,&Rdate[0]}, /* Revision date */
    {sizeof(Cdate),ATR$C_CREDATE,&Cdate[0]}, /* Creation date */
    {0,0,0}
  };
  static short int DevChan;
  static short int iosb[4];

  name = vmsify (name, 0);

  /* initialize RMS structures, we need a NAM to retrieve the FID */
  Fab = cc$rms_fab;
  Fab.fab$l_fna = name ; /* name of file */
  Fab.fab$b_fns = strlen(name);
  Fab.fab$l_nam = &Nam; /* FAB has an associated NAM */
      
  Nam = cc$rms_nam;
  Nam.nam$l_esa = EName; /* expanded filename */
  Nam.nam$b_ess = sizeof(EName);
  Nam.nam$l_rsa = RName; /* resultant filename */
  Nam.nam$b_rss = sizeof(RName);

  /* do $PARSE and $SEARCH here */
  status = sys$parse(&Fab);
  if (!(status & 1))
    return -1;

  DevDesc.dsc$w_length = Nam.nam$t_dvi[0];
  status = sys$assign(&DevDesc,&DevChan,0,0);
  if (!(status & 1))
    return -1;

  FileName.dsc$a_pointer = Nam.nam$l_name;
  FileName.dsc$w_length = Nam.nam$b_name+Nam.nam$b_type+Nam.nam$b_ver;
  
  /* Initialize the FIB */
  for (i=0;i<3;i++)
    {
#if __DECC
      Fib.fib$w_fid[i]=Nam.nam$w_fid[i];
      Fib.fib$w_did[i]=Nam.nam$w_did[i];
#else
      Fib.fib$r_fid_overlay.fib$w_fid[i]=Nam.nam$w_fid[i];
      Fib.fib$r_did_overlay.fib$w_did[i]=Nam.nam$w_did[i];
#endif
    }

  status = sys$qiow(0,DevChan,IO$_ACCESS,&iosb,0,0,
                        &FibDesc,&FileName,0,0,&Atr,0);
  sys$dassgn (DevChan);
  if (!(status & 1))
    return -1;
  status = iosb[0];
  if (!(status & 1))
    return -1;

  status = stat (name, buf);
  if (status)
    return -1;

  buf->st_mtime = ((Rdate[0]>>24) & 0xff) + ((Rdate[1]<<8) & 0xffffff00);
  buf->st_ctime = ((Cdate[0]>>24) & 0xff) + ((Cdate[1]<<8) & 0xffffff00);
  return 0;
}

