#define TEST 0
/*
   jpilib.c

   JPI support routines for openVMS/Alpha

   This is for openVMS with EGCS 1.1 (based on GNU C 2.8)

   Copyright  by Klaus Kmpf (kkaempf@rmi.de) 1998

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that: (1) source code distributions
   retain the above copyright notice and this paragraph in its entirety, (2)
   distributions including binary code include the above copyright notice and
   this paragraph in its entirety in the documentation or other materials
   provided with the distribution, and (3) all advertising materials mentioning
   features or use of this software display the following acknowledgement:
   ``This product includes software developed by Klaus Kmpf, Nrnberg,
   Germany.''
   THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR IMPLIED
   WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
   MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.

 */

#include <sys$routines.h>
#include <jpidef.h>
#include <errno.h>
#include <reent.h>

#include "vmserrnor.h"
#include "jpilib.h"

/*
   get JPI string value

   I:	jpicode	JPI$	code
   IO:	buf		buffer
   I:	size		buffer size

   returns string length or -1 on error

 */

int
jpi_string_r (struct _reent *ptr, int jpicode, char *buf, int size)
{
  long status;
  short length;
  static struct itemdesc jpilist[2] = {
    { 0, 0, 0, 0 },
    { 0, 0, 0, 0 }
  };

  jpilist[0].length = size;
  jpilist[0].code = jpicode;
  jpilist[0].buffer = buf;
  jpilist[0].buflen = &length;

  status = SYS$GETJPIW (0, 0, 0, jpilist, 0, 0, 0);

  if (!(status & 1))
    {
      set_vms_error_r (ptr, status);
      return -1;
    }
  if (length <= 0)
    {
      ptr->_errno = EINVAL;
      return -1;
    }

  return length;
}


long
jpi_long_r (struct _reent *ptr, int jpicode)
{
  long status;
  long value;
  short vlen;
  static struct itemdesc jpilist[2] = {
    { 0, 0, 0, 0 },
    { 0, 0, 0, 0 }
  };

  jpilist[0].length = sizeof (long);
  jpilist[0].code = jpicode;
  jpilist[0].buffer = &value;
  jpilist[0].buflen = &vlen;

  status = SYS$GETJPIW (0, 0, 0, jpilist, 0, 0, 0);

  if (!(status & 1))
    {
      set_vms_error_r (ptr, status);
      return -1;
    }
  if (vlen <= 0)
    {
      ptr->_errno = EINVAL;
      return -1;
    }

  return value;
}


/* EOF */
