/*
   vmserrno.c

   This is for openVMS with EGCS 1.1 (based on GNU C 2.8)

   Copyright  by Klaus Kmpf (kkaempf@rmi.de) 1998

   Redistribution and use in source and binary forms, with or without
   modification, are permitted provided that: (1) source code distributions
   retain the above copyright notice and this paragraph in its entirety, (2)
   distributions including binary code include the above copyright notice and
   this paragraph in its entirety in the documentation or other materials
   provided with the distribution, and (3) all advertising materials mentioning
   features or use of this software display the following acknowledgement:
   ``This product includes software developed by Klaus Kmpf, Nrnberg,
   Germany.''
   THIS SOFTWARE IS PROVIDED ``AS IS'' AND WITHOUT ANY EXPRESS OR IMPLIED
   WARRANTIES, INCLUDING, WITHOUT LIMITATION, THE IMPLIED WARRANTIES OF
   MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE.

 */

#include <vms/rmsdef.h>
#include <vms/ssdef.h>

#include <reent.h>
#include <errno.h>

/*
   convert vms status code to un*x errno value

 */

void
set_vms_error_r (struct _reent *ptr, int status)
{
  ptr->_vmserrno = status;
  switch (status)
    {
      case SS$_IVIDENT:
	ptr->_errno = EINVAL;
	break;
      case RMS$_DEV:
	ptr->_errno = ENODEV;
	break;
      case RMS$_DNR:
      case RMS$_DIR:
      case RMS$_DNF:
      case RMS$_FNF:
      case RMS$_RNF:
	ptr->_errno = ENOENT;
	break;
      case RMS$_PRV:
	ptr->_errno = EPERM;
	break;
      default:
	ptr->_errno = EVMSERR;
	break;
    }

  return;
}

/* EOF */
